App({
	onLaunch: function () {
		this.isReload() // 小程序是否有新版本
		this.getToken()
	},
	// 小程序是否有新版本
	isReload: function () {
		let that = this
		if (wx.canIUse('getUpdateManager')) {
			const updateManager = wx.getUpdateManager()
			updateManager.onCheckForUpdate(function (res) {
				if (res.hasUpdate) {
					updateManager.onUpdateReady(function () {
						wx.showModal({
							title: '更新提示',
							content: '新版本已经准备好，是否重启应用？',
							success: function (res) {
								if (res.confirm) {
									updateManager.applyUpdate()
								}
							}
						})
					})
					updateManager.onUpdateFailed(function () {
						wx.showModal({
							title: '已经有新版本了哟~',
							content: '新版本已经上线啦，请您删除当前小程序，重新搜索打开！'
						})
					})
				}
			})
		} else {
			wx.showModal({
				title: '提示',
				content: '当前微信版本过低，无法使用该功能，请升级到最新微信版本后重试！'
			})
		}
	},
	getToken() {
		var that = this
		try {
			var token = wx.getStorageSync('token')
			if (token) {
				that.globalData.token = token
			}
		} catch (e) {}
	},
	// 获取sessionkey 提交后台换取基本openid unionid
	getSessionKey: function (cb) {
		let that = this
		wx.login({
			success: function (res) {
				that.codeChangeToken(res.code, cb)
			}
		})
	},
	// sessionkey 换取token
	codeChangeToken(code, cb) {
		let that = this
		wx.request({
			url: that.globalData.baseUrl + 'getsessionkey',
			data: {
				code: code
			},
			header: {
				'app': 'coach'
			},
			method: 'GET',
			success: function (res) {
				if (res.data.meta.code === 200) {
					try {
						wx.setStorageSync('token', res.data.data.token)
					} catch (e) {
						console.log('token缓存失败')
					}
					that.globalData.token = res.data.data.token
					typeof cb == 'function' && cb()
				} else {
					console.log(res)
				}
			}
		})
	},
	// 保存用户信息
	saveUserInfo: function (info, cb) {
		let that = this
		wx.checkSession({
			success() {
				wx.request({
					url: that.globalData.baseUrl + 'saveinfo',
					data: {
						encryptedData: encodeURIComponent(info.encryptedData),
						iv: encodeURIComponent(info.iv),
						token: that.globalData.token
					},
					header: {
						'app': 'coach'
					},
					method: 'POST',
					success: function (res) {
						if (res.data.meta.code == 200) {
							wx.showToast({
								title: '授权成功',
								icon: 'none',
								duration: 2000
							})
							that.globalData.hasTel = res.data.data.hasTel
							that.globalData.userInfo = res.data.data;
							console.log(that.globalData.userInfo)
							wx.setStorageSync('userInfo', res.data.data)
							if (res.data.data.userTel) {
								wx.setStorageSync('userTel', res.data.data.userTel)
							}
						} else {
							wx.showToast({
								title: res.data.meta.message,
								icon: 'none',
								duration: 2000
							})
						}
						typeof cb == 'function' && cb()
					},
					fail: function () {}
				})
			},
			fail() { // session_key 已经失效，需要重新执行登录流程
				that.getSessionKey(() => that.saveUserInfo(info, cb))
			}
		})
	},

	globalData: {
		baseUrl: 'https://wandoutiyu.xueyoubangedu.com/api/', //线上接口
		// baseUrl: 'https://wandoutiyu.test.xueyoubangedu.com/api/', //测试接口
		extAppid: 'wx6e6eaca9cc1c406d', // 当前appid
		userInfo: '', //微信user信息
		userTel: '', //  手机号
		token: '',
		backurl: '', // 全局跳转页面路径
		coach_id: '', // 教练id
		classRush: false // 抢班是否成功
	}
})